﻿<Serializable()>
Public Class BOBSettings
    'Properties with default values
    Public Property SourceFolder = "C:\Code\BackupOnBuild"
    Public Property BackupFolder = "C:\Code\Backup\BackupOnBuild"
    Public Property TextLog = True
    'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
    '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
    Public Property FullBackupSchedule = "Weekly"
    Public Property SkippedExtensionReport = True
    Public Property CompletedNotification = True
    Public Property CompressBackup = True
    'Suggested Extensions: bmp, cur, doc, docx, ico, txt
    Public Property Extensions = "asax;ascx;ashx;browser;cd;config;css;cs;disco;" +
        "js;jsl;master;mdf;rdlc;resx;rpt;settings;sitemap;skin;sln;suo;vb;vbproj;" +
        "vbs;wsf;xlst;xml;xsd"


    ''' <summary>
    ''' Save the application settings as an XML file
    ''' </summary>
    ''' <param name="FullPathFileName">Fully qualified filename for the settings file</param>
    ''' <param name="Settings">An instance of BOBSettings with the values to save</param>
    ''' <remarks></remarks>
    Public Shared Sub Save(ByVal FullPathFileName As String, ByVal Settings As BOBSettings)
        Try
            Dim sr As New IO.StreamWriter(FullPathFileName)
            Dim xs As New Xml.Serialization.XmlSerializer(GetType(BOBSettings))
            xs.Serialize(sr, Settings)
            sr.Close()
            sr.Dispose()
        Catch ex As Exception
            Throw New Exception("BackupOnBuild:BOBSettings:Save:Error: " + ex.Message, ex)
        End Try
    End Sub

    ''' <summary>
    ''' Loads the application settings from the specified xml file
    ''' </summary>
    ''' <param name="FullPathFileName">Fully qualified filename for the settings file</param>
    ''' <returns>An instance of the BOBSettings class with values from the file</returns>
    ''' <remarks></remarks>
    Public Shared Function Load(ByVal FullPathFileName As String) As BOBSettings
        Try
            Dim xmlr As New IO.StreamReader(FullPathFileName)
            Dim xs As New Xml.Serialization.XmlSerializer(GetType(BOBSettings))
            Dim oSettings As BOBSettings = xs.Deserialize(xmlr)
            Return oSettings
        Catch ex As Exception
            Throw New Exception("BackupOnBuild:BOBSettings:Load:Error: " + ex.Message, ex)
        End Try
    End Function
End Class
