﻿<Serializable()>
Public Class BOBSettings
    Public Property SourceFolder = "C:\Code\BackupOnBuild"
    Public Property BackupFolder = "C:\Code\Backup\BackupOnBuild"
    Public Property TextLog = True
    Public Property FullBackupSchedule = "Weekly"
    Public Property SkippedExtensionReport = True
    Public Property CompletedNotification = True
    Public Property CompressBackup = True
    Public Property Extensions = "asax;ascx;ashx;bmp;browser;cd;config;css;cs;cur;disco;ico;js;jsl;master;mdf;rdlc;resx;rpt;settings;sitemap;skin;sln;suo;txt;vb;vbproj;vbs;wsf;xlst;xml;xsd"

    Public Shared Sub Save(ByVal FullPathFileName As String, ByVal Settings As BOBSettings)
        Try
            Dim sr As New IO.StreamWriter(FullPathFileName)
            Dim xs As New Xml.Serialization.XmlSerializer(GetType(BOBSettings))
            xs.Serialize(sr, Settings)
        Catch ex As Exception
            Throw New Exception("BackupOnBuild:BOBSettings:Save:Error: " + ex.Message, ex)
        End Try
    End Sub

    Public Shared Function Load(ByVal FullPathFileName As String) As BOBSettings
        Try
            Dim xmlr As New IO.StreamReader(FullPathFileName)
            Dim xs As New Xml.Serialization.XmlSerializer(GetType(BOBSettings))
            Dim oSettings As BOBSettings = xs.Deserialize(xmlr)
            Return oSettings
        Catch ex As Exception
            Throw New Exception("BackupOnBuild:BOBSettings:Load:Error: " + ex.Message, ex)
        End Try
    End Function
End Class
