﻿Imports Microsoft.VisualStudio.TestTools.UnitTesting

Imports BackupOnBuild



'''<summary>
'''This is a test class for BOBSettingsTest and is intended
'''to contain all BOBSettingsTest Unit Tests
'''</summary>
<TestClass()> _
Public Class BOBSettingsTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region


    '''<summary>
    '''A test for BOBSettings Constructor
    '''</summary>
    <TestMethod()> _
    Public Sub BOBSettingsConstructorTest()
        Dim target As BOBSettings = New BOBSettings()
        Assert.AreEqual(target.BackupFolder, "C:\Code\Backup\BackupOnBuild")
        Assert.AreEqual(target.BackupFolder, "C:\Code\Backup\BackupOnBuild")
        Assert.AreEqual(target.TextLog, True)
        'Possible Values:   Always, Never, Monthly, BiWeekly, Weekly, Daily, Hourly, 
        '                   Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday
        Assert.AreEqual(target.FullBackupSchedule, "Weekly")
        Assert.AreEqual(target.SkippedExtensionReport, True)
        Assert.AreEqual(target.CompletedNotification, True)
        Assert.AreEqual(target.CompressBackup, True)
        Assert.AreEqual(target.Extensions, "asax;ascx;ashx;bmp;browser;cd;config;css;cs;cur;disco;" +
            "ico;js;jsl;master;mdf;rdlc;resx;rpt;settings;sitemap;skin;sln;suo;txt;vb;vbproj;" +
            "vbs;wsf;xlst;xml;xsd")

    End Sub

    '''<summary>
    '''A test for Load
    '''</summary>
    <TestMethod()> _
    Public Sub LoadTest()
        Dim FullPathFileName As String = My.Application.Info.DirectoryPath + "\TestSettings.xml"
        Dim expected As New BOBSettings
        expected.BackupFolder = "test_backupfolder"
        expected.CompletedNotification = False
        expected.CompressBackup = False
        expected.Extensions = "test_extensions"
        expected.FullBackupSchedule = "test_fullbackupschedule"
        expected.SkippedExtensionReport = False
        expected.SourceFolder = "test_sourcefolder"
        expected.TextLog = False


        Dim actual As BOBSettings
        actual = BOBSettings.Load(FullPathFileName)
        Assert.AreEqual(expected.BackupFolder, actual.BackupFolder)
        Assert.AreEqual(expected.CompletedNotification, actual.CompletedNotification)
        Assert.AreEqual(expected.CompressBackup, actual.CompressBackup)
        Assert.AreEqual(expected.Extensions, actual.Extensions)
        Assert.AreEqual(expected.FullBackupSchedule, actual.FullBackupSchedule)
        Assert.AreEqual(expected.SkippedExtensionReport, actual.SkippedExtensionReport)
        Assert.AreEqual(expected.SourceFolder, actual.SourceFolder)
        Assert.AreEqual(expected.TextLog, actual.TextLog)
    End Sub

    '''<summary>
    '''A test for Save
    '''</summary>
    <TestMethod()> _
    Public Sub SaveTest()
        Dim FullPathFileName As String = My.Application.Info.DirectoryPath + "\TestSaveSettings.xml"
        Dim expected As New BOBSettings
        expected.BackupFolder = "test_backupfolder"
        expected.CompletedNotification = False
        expected.CompressBackup = False
        expected.Extensions = "test_extensions"
        expected.FullBackupSchedule = "test_fullbackupschedule"
        expected.SkippedExtensionReport = False
        expected.SourceFolder = "test_sourcefolder"
        expected.TextLog = False

        BOBSettings.Save(FullPathFileName, expected)
        Dim actual As BOBSettings = BOBSettings.Load(FullPathFileName)

        Assert.AreEqual(expected.BackupFolder, actual.BackupFolder)
        Assert.AreEqual(expected.CompletedNotification, actual.CompletedNotification)
        Assert.AreEqual(expected.CompressBackup, actual.CompressBackup)
        Assert.AreEqual(expected.Extensions, actual.Extensions)
        Assert.AreEqual(expected.FullBackupSchedule, actual.FullBackupSchedule)
        Assert.AreEqual(expected.SkippedExtensionReport, actual.SkippedExtensionReport)
        Assert.AreEqual(expected.SourceFolder, actual.SourceFolder)
        Assert.AreEqual(expected.TextLog, actual.TextLog)
    End Sub

    '''<summary>
    '''A test for BackupFolder
    '''</summary>
    <TestMethod()> _
    Public Sub BackupFolderTest()
        Dim target As BOBSettings = New BOBSettings()
        target.BackupFolder = "test_backupfolder"
        Assert.AreEqual(target.BackupFolder, "test_backupfolder")
        Assert.IsInstanceOfType(target.BackupFolder, GetType(String))
    End Sub

    '''<summary>
    '''A test for CompletedNotification
    '''</summary>
    <TestMethod()> _
    Public Sub CompletedNotificationTest()
        Dim target As BOBSettings = New BOBSettings()
        target.CompletedNotification = True
        Assert.AreEqual(target.CompletedNotification, True)
        Assert.IsInstanceOfType(target.CompletedNotification, GetType(Boolean))
    End Sub

    '''<summary>
    '''A test for CompressBackup
    '''</summary>
    <TestMethod()> _
    Public Sub CompressBackupTest()
        Dim target As BOBSettings = New BOBSettings()
        target.CompressBackup = True
        Assert.AreEqual(target.CompressBackup, True)
        Assert.IsInstanceOfType(target.CompressBackup, GetType(Boolean))
    End Sub

    '''<summary>
    '''A test for Extensions
    '''</summary>
    <TestMethod()> _
    Public Sub ExtensionsTest()
        Dim target As BOBSettings = New BOBSettings()
        target.Extensions = "test_extensions"
        Assert.AreEqual(target.Extensions, "test_extensions")
        Assert.IsInstanceOfType(target.Extensions, GetType(String))
    End Sub

    '''<summary>
    '''A test for FullBackupSchedule
    '''</summary>
    <TestMethod()> _
    Public Sub FullBackupScheduleTest()
        Dim target As BOBSettings = New BOBSettings()
        target.FullBackupSchedule = "test_schedule"
        Assert.AreEqual(target.FullBackupSchedule, "test_schedule")
        Assert.IsInstanceOfType(target.FullBackupSchedule, GetType(String))
    End Sub

    '''<summary>
    '''A test for SkippedExtensionReport
    '''</summary>
    <TestMethod()> _
    Public Sub SkippedExtensionReportTest()
        Dim target As BOBSettings = New BOBSettings()
        target.SkippedExtensionReport = True
        Assert.AreEqual(target.SkippedExtensionReport, True)
        Assert.IsInstanceOfType(target.SkippedExtensionReport, GetType(Boolean))
    End Sub

    '''<summary>
    '''A test for SourceFolder
    '''</summary>
    <TestMethod()> _
    Public Sub SourceFolderTest()
        Dim target As BOBSettings = New BOBSettings()
        target.SourceFolder = "test_source"
        Assert.AreEqual(target.SourceFolder, "test_source")
        Assert.IsInstanceOfType(target.SourceFolder, GetType(String))
    End Sub

    '''<summary>
    '''A test for TextLog
    '''</summary>
    <TestMethod()> _
    Public Sub TextLogTest()
        Dim target As BOBSettings = New BOBSettings()
        target.TextLog = True
        Assert.AreEqual(target.TextLog, True)
        Assert.IsInstanceOfType(target.TextLog, GetType(Boolean))
    End Sub
End Class
